#!/bin/bash
##############################################################
### Created By Farhad Arghavan ( farhadarghavan@yahoo.com ) ##
################## Maemo.org ID ( farfary ) ##################
## Backdeb : this script backup the package user installed #
##############################################################

mkdir -p /home/user/MyDocs/BackDeb/User 2>/dev/null

##### Wrong Start #####

if [ ! "$package" ]
then
    echo "Usage: $0 package"
    exit 1
fi

##### Package Not Found #####

if ! control="$(dpkg -p "$package" 2> /dev/null)"
then
    echo "## Package $package not found !!"
	echo "## Or this Package is a Orig App"
    exit 1
fi

##### Tmp Folder Creat #####

rm -rf /home/.backdebtmp/
mkdir -p /home/.backdebtmp/debtmp
dir="/home/.backdebtmp/debtmp"
cd "$dir"
mkdir /home/.backdebtmp/debtmp/DEBIAN

##### Package Control File

echo "  Creat Package Control File For $package ..."
printf "\033[1A"
printf "\033[K"
echo "  Creat Package Control File For $package ... Done"

echo "$control" > "DEBIAN/control.1"

sed -e "/$Aegis-Manifest*/d" DEBIAN/control.1  > DEBIAN/control.2

grep  "Version: " DEBIAN/control.2 > DEBIAN/ver

mv DEBIAN/control.2 DEBIAN/control

sed -i  's/Version: /VERSION=_/g' DEBIAN/ver

mv DEBIAN/ver /home/.backdebtmp/backdebpkgver

rm -rf DEBIAN/*.*

. /home/.backdebtmp/backdebpkgver

##### Package File #####

echo "  Export Package File ..."
printf "\033[1A"
printf "\033[K"
echo "  Export Package File ... Done"

for f in $(dpkg -L "$package")
do
    if [ -d "$f" ]
    then
        mkdir -p "./$f"
    elif [ -f "$f" ]
    then
        cp "$f" "./$f"
    fi
done

##### Package Digsigsums #####

echo "  Creat Package Digsigsums & md5sums ..."
printf "\033[1A"
printf "\033[K"
echo "  Creat Package Digsigsums & md5sums ... Done"

find | grep -v "./DEBIAN" > /home/.backdebtmp/backdebdig

while read line
do
 if [ -f "$line" ]; then
  #cut "./" from beginning
  line=`echo "$line" | cut -c 3-`

  #get md5
  md5sum "$line" >> DEBIAN/md5sums

  #get sha1 for digital signatures
  echo S 15 com.nokia.maemo H 40 `sha1sum "$line" | cut -c -40` R `expr length "$line"` $line >> DEBIAN/digsigsums
 fi
done < "/home/.backdebtmp/backdebdig"

rm -f /home/.backdebtmp/backdebdig

##### Install & Unistall Scripts #####

echo "  Add Install & Unistall Scripts ..."
printf "\033[1A"
printf "\033[K"
echo "  Add Install & Unistall Scripts ... Done"

cp -R /var/lib/dpkg/info/$package*inst /home/.backdebtmp/debtmp/DEBIAN 2>/dev/null
cp -R /var/lib/dpkg/info/$package*rm /home/.backdebtmp/debtmp/DEBIAN 2>/dev/null
cd /home/.backdebtmp/debtmp/
mv DEBIAN/*postinst DEBIAN/postinst 2>/dev/null
mv DEBIAN/*preinst DEBIAN/preinst 2>/dev/null
mv DEBIAN/*postrm DEBIAN/postrm 2>/dev/null
mv DEBIAN/*prerm DEBIAN/prerm 2>/dev/null

##### Packing TO DEB #####

echo "  Packing The $package ..."
printf "\033[1A"
printf "\033[K"
echo "  Packing The $package ... Done"

cd /home/.backdebtmp/debtmp
tar -cvzf ../control.tar.gz -C DEBIAN/ . >/dev/null
rm -rf /home/.backdebtmp/debtmp/DEBIAN
tar -cvzf ../data.tar.gz . >/dev/null
echo 2.0 > ../debian-binary
cd /home/.backdebtmp/

ar -rcv /home/.backdebtmp/$package$VERSION\_armel.deb debian-binary control.tar.gz data.tar.gz >/dev/null
devel-su user -c "cp -f /home/.backdebtmp/$package$VERSION\_armel.deb /home/user/MyDocs/BackDeb/User"

##### Tmp Folder Clean #####

echo "  Remove Tmp ..."
printf "\033[1A"
printf "\033[K"
echo "  Remove Tmp ... Done"

rm -rf "$dir"
rm -rf /home/.backdebtmp
echo "  Packaging $package FINISHED !"
echo "## Saved deb to: /home/user/MyDocs/BackDeb/User/$package$VERSION._armel.deb"


    exit 1
	
##### END #####