import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0

PageStackWindow {
    id: appWindow

    initialPage: lockMePage

    Page{
        id: lockMePage
        anchors.fill: parent

        //tools: commonTools

        orientationLock: PageOrientation.LockPortrait

        Rectangle{
            id: mainPageTitle
            y:0
            x:0
            width: parent.width
            height: 72;
            color: "green"

            Label {
                id: mainPageTitleText
                anchors.left: parent.left
                anchors.leftMargin: 15
                anchors.verticalCenter: parent.verticalCenter
                font.pixelSize: 35
                color:  "white"
                text: "LockApp"
            }

            Label {
                id: mainPageAuthorText
                x: mainPageTitle.width-15-mainPageAuthorText.width
                anchors.verticalCenter: parent.verticalCenter
                font.pixelSize: 30
                color:  "white"
                text: "By Iktwo"
            }
        }

        Label{
            id: lblPass
            text: "Password:"
            anchors.verticalCenter: txtPass.verticalCenter
            x: 10
        }

        TextField{
            id: txtPass
            y: mainPageTitle.height + 20
            x: lblPass.width+20
            width: parent.width-txtPass.x
            echoMode: TextInput.Password

            platformSipAttributes: SipAttributes {
                actionKeyLabel: "Validate"
                actionKeyHighlighted: true
            }

            Keys.onReturnPressed: {
                wMain.getStringSetting("12345","12345");
                if(txtPass.text===settingResult){
                    infoBanner.text="Loading Application";
                    infoBanner.show();
                    wMain.startApplicationDetached();
                }else{
                    infoBanner.text="Incorrect Password";
                    infoBanner.show();
                }
            }
        }

        Button{
            anchors {
                horizontalCenter: parent.horizontalCenter
                top: txtPass.bottom
                topMargin: 10
            }
            text: qsTr("Validate")
            onClicked: {
                wMain.getStringSetting("12345","12345");
                if(txtPass.text===settingResult){
                    infoBanner.text="Loading Application";
                    infoBanner.show();
                    wMain.startApplicationDetached();
                }else{
                    infoBanner.text="Incorrect Password";
                    infoBanner.show();
                }
            }
        }

        InfoBanner{
            id: infoBanner
            timerEnabled: true
            timerShowTime: 3500
            z: 1
        }
    }
}
